var loopback = require('./');
var request = require('supertest');
var app = module.exports = loopback();

app.dataSource('db', { connector: 'memory' });

var Category = app.model('Category', {
  properties: { name: 'string' },
  dataSource: 'db' 
});

var Product = app.model('Product', {
  properties: { name: 'string' },
  options: {
    relations: {
      category: {
        model: 'Category',
        type: 'belongsTo',
      }
    }
  },
  dataSource: 'db'
});

app.use(loopback.rest());

Category.create({ name: 'a-cat' }, function(err, cat) {
  if (err) throw err;
  console.log('created category', cat);
  
  Product.create({ name: 'a-prod', categoryId: cat.id }, function (err, prod) {
    if (err) throw err;
    console.log('created product', prod);

    prod.category(function(err, cat2) {
      if (err) throw err;
      console.log('product\'s category', cat2);

      request(app)
        .get('/products/' + prod.id + '/category?refresh=true')
        .end(function(err, res) {
          if (err) throw err;
          console.log('REST response', res.statusCode);
          console.log(res.body);
        });
    });
  });
});
