var loopback = require('./');
var app = loopback();

app.dataSource('db', { connector: 'memory' });

var Product = app.model('Product', {
  options: {
    relations: {
      categories: {
        model: 'Category',
        type: 'hasAndBelongsToMany',
      }
    }
  },
  dataSource: 'db'
});

var Category = app.model('Category', {
  options: {
    relations: {
      categories: {
        model: 'Product',
        type: 'hasAndBelongsToMany',
      }
    }
  },
  dataSource: 'db'
});

function test(cb) {
console.log('Product.prototype =', Object.keys(Product.prototype));
console.log('Product.prototype.categories is', typeof Product.prototype.categories);
console.log('relations', Product.relations);

Product.create({}, function(err, p) {
  if (err) throw err;
  console.log('product created', p);

  p.categories(function(err, list) {
    if (err) throw err;
    console.log('initial categories', list);

    p.categories.create({}, function(err, cat) {
      if (err) throw err;
      console.log('category created', cat);

      p.categories(true, function(err, list2) {
        if (err) throw err;
        console.log('new categories', list2);
      });
    });
  });
});
}

test();
